diff --git a/yum/__init__.py b/yum/__init__.py
index 99039e0..bf13f40 100644
--- a/yum/__init__.py
+++ b/yum/__init__.py
@@ -4183,16 +5548,15 @@ class YumBase(depsolve.Depsolve):
         return tx_return
 
     def reinstallLocal(self, pkg, po=None):
+        """Mark a package on the local filesystem (i.e. not from a
+        repository) for reinstallation. 
+        
+        :param pkg: a string specifying the path to an rpm file in the
+           local filesystem to be marked for reinstallation
+        :param po: a :class:`yum.packages.YumLocalPackage` 
+        :return: a list of the transaction members added to the
+           transaction set by this method
         """
-        handles reinstall of rpms provided on the filesystem in a
-        local dir (ie: not from a repo)
-
-        Return the added transaction members.
-
-        @param pkg: a path to an rpm file on disk.
-        @param po: A YumLocalPackage
-        """
-
         if not po:
             try:
                 po = YumUrlPackage(self, ts=self.rpmdb.readOnlyTS(), url=pkg,
@@ -4215,13 +5579,29 @@ class YumBase(depsolve.Depsolve):
         return self.reinstall(po=po)
 
     def reinstall(self, po=None, **kwargs):
-        """Setup the problem filters to allow a reinstall to work, then
-           pass everything off to install"""
-           
+        """Mark the given package for reinstallation.  This is
+        accomplished by setting problem filters to allow a reinstall
+        take place, then calling :func:`install`.
+
+        :param po: the package object to mark for reinstallation
+        :param kwargs: if po is not given, the keyword will be used to
+           specify a package for reinstallation
+        :return: a list of the transaction members added to the
+           transaction set by this method
+        :raises: :class:`yum.Errors.ReinstallRemoveError` or
+           :class:`yum.Errors.ReinstallInstallError` depending the nature
+           of the error that is encountered
+        """
         self._add_prob_flags(rpm.RPMPROB_FILTER_REPLACEPKG,
                              rpm.RPMPROB_FILTER_REPLACENEWFILES,
                              rpm.RPMPROB_FILTER_REPLACEOLDFILES)
 
+        # NOTE: For repoid=foo we could do two things:
+        # 1. Only do the "remove" op. with packages installed from "foo".
+        # 2. Only do the "install" op. with packages available from "foo".
+        # ...so repoid=foo means #1 and repoid_install=foo means #2. Can also
+        # combine them.
+
         tx_mbrs = []
         if po: # The po, is the "available" po ... we want the installed po
             tx_mbrs.extend(self.remove(pkgtup=po.pkgtup))
@@ -4240,10 +5620,11 @@ class YumBase(depsolve.Depsolve):
             # pkgs that are obsolete.
             old_conf_obs = self.conf.obsoletes
             self.conf.obsoletes = False
-            if isinstance(po, YumLocalPackage):
+            if isinstance(po, YumLocalPackage) and 'repoid' not in kwargs:
                 members = self.install(po=po)
             else:
-                members = self.install(pkgtup=item.pkgtup)
+                members = self.install(pkgtup=item.pkgtup,
+                                       repoid=kwargs.get('repoid_install'))
             self.conf.obsoletes = old_conf_obs
             if len(members) == 0:
                 self.tsInfo.remove(item.pkgtup)
@@ -4259,16 +5640,15 @@ class YumBase(depsolve.Depsolve):
         return tx_mbrs
         
     def downgradeLocal(self, pkg, po=None):
+        """Mark a package on the local filesystem (i.e. not from a
+        repository) to be downgraded.
+        
+        :param pkg: a string specifying the path to an rpm file in the
+           local filesystem to be marked to be downgraded
+        :param po: a :class:`yum.packages.YumLocalPackage` 
+        :return: a list of the transaction members added to the
+           transaction set by this method
         """
-        handles downgrades of rpms provided on the filesystem in a
-        local dir (ie: not from a repo)
-
-        Return the added transaction members.
-
-        @param pkg: a path to an rpm file on disk.
-        @param po: A YumLocalPackage
-        """
-
         if not po:
             try:
                 po = YumUrlPackage(self, ts=self.rpmdb.readOnlyTS(), url=pkg,
@@ -4309,13 +5689,19 @@ class YumBase(depsolve.Depsolve):
         return False
         
     def downgrade(self, po=None, **kwargs):
-        """ Try to downgrade a package. Works like:
-            % yum shell <<EOL
-            remove  abcd
-            install abcd-<old-version>
-            run
-            EOL """
-
+        """Mark a package to be downgraded.  This is equivalent to
+        first removing the currently installed package, and then
+        installing the older version.
+
+        :param po: the package object to be marked to be downgraded
+        :param kwargs: if a package object is not given, the keyword
+           arguments will be used to specify a package to be marked to
+           be downgraded
+        :return: a list of the transaction members added to the
+           transaction set by this method
+        :raises: :class:`yum.Errors.DowngradeError` if no packages are
+           specified or available for downgrade
+        """
         if not po and not kwargs:
             raise Errors.DowngradeError, 'Nothing specified to downgrade'
 
@@ -4397,6 +5783,10 @@ class YumBase(depsolve.Depsolve):
         # installed version. Indexed fromn the latest installed pkgtup.
         downgrade_apkgs = {}
         for pkg in sorted(apkgs):
+            # We are cleverer here, I think...
+            # if not self._valid_install_arch(pkg, ipkgs):
+            # continue
+
             na  = (pkg.name, pkg.arch)
 
             # Here we allow downgrades from .i386 => .noarch, or .i586 => .i386
@@ -4421,6 +5811,9 @@ class YumBase(depsolve.Depsolve):
                 warned_nas.add(na)
                 continue
 
+            if pkg.verEQ(lipkg):
+                continue
+
             if pkg.verGE(lipkg):
                 if na not in warned_nas:
                     msg = _('Only Upgrade available on package: %s') % pkg
@@ -4457,7 +5850,7 @@ class YumBase(depsolve.Depsolve):
         if e and v and r:
             evr = '%s:%s-%s' % (e, v, r)
         elif v and r:
-            evr = '%s-%s' % (e, v, r)
+            evr = '%s-%s' % (v, r)
         elif e and v:
             evr = '%s:%s' % (e, v)
         elif v: # e and r etc. is just too weird to print
@@ -4500,12 +5893,24 @@ class YumBase(depsolve.Depsolve):
 
         return returndict
 
-    def history_redo(self, transaction):
-        """ Given a valid historical transaction object, try and repeat
-            that transaction. """
+    def history_redo(self, transaction,
+                     force_reinstall=False, force_changed_removal=False):
+        """Repeat the transaction represented by the given
+        :class:`yum.history.YumHistoryTransaction` object.
+
+        :param transaction: a
+           :class:`yum.history.YumHistoryTransaction` object
+           representing the transaction to be repeated
+        :param force_reinstall: bool - do we want to reinstall anything that was
+           installed/updated/downgraded/etc.
+        :param force_changed_removal: bool - do we want to force remove anything
+           that was downgraded or upgraded.
+        :return: whether the transaction was repeated successfully
+        """
         # NOTE: This is somewhat basic atm. ... see comment in undo.
         #  Also note that redo doesn't force install Dep-Install packages,
         # which is probably what is wanted the majority of the time.
+
         old_conf_obs = self.conf.obsoletes
         self.conf.obsoletes = False
         done = False
@@ -4515,19 +5920,46 @@ class YumBase(depsolve.Depsolve):
                     done = True
         for pkg in transaction.trans_data:
             if pkg.state == 'Downgrade':
+                if force_reinstall and self.rpmdb.searchPkgTuple(pkg.pkgtup):
+                    if self.reinstall(pkgtup=pkg.pkgtup):
+                        done = True
+                    continue
+
                 try:
                     if self.downgrade(pkgtup=pkg.pkgtup):
                         done = True
                 except yum.Errors.DowngradeError:
                     self.logger.critical(_('Failed to downgrade: %s'), pkg)
         for pkg in transaction.trans_data:
+            if force_changed_removal and pkg.state == 'Downgraded':
+                if self.tsInfo.getMembers(pkg.pkgtup):
+                    continue
+                if self.remove(pkgtup=pkg.pkgtup, silence_warnings=True):
+                    done = True
+        for pkg in transaction.trans_data:
             if pkg.state == 'Update':
+                if force_reinstall and self.rpmdb.searchPkgTuple(pkg.pkgtup):
+                    if self.reinstall(pkgtup=pkg.pkgtup):
+                        done = True
+                    continue
+
                 if self.update(pkgtup=pkg.pkgtup):
                     done = True
                 else:
                     self.logger.critical(_('Failed to upgrade: %s'), pkg)
         for pkg in transaction.trans_data:
+            if force_changed_removal and pkg.state == 'Updated':
+                if self.tsInfo.getMembers(pkg.pkgtup):
+                    continue
+                if self.remove(pkgtup=pkg.pkgtup, silence_warnings=True):
+                    done = True
+        for pkg in transaction.trans_data:
             if pkg.state in ('Install', 'True-Install', 'Obsoleting'):
+                if force_reinstall and self.rpmdb.searchPkgTuple(pkg.pkgtup):
+                    if self.reinstall(pkgtup=pkg.pkgtup):
+                        done = True
+                    continue
+
                 if self.install(pkgtup=pkg.pkgtup):
                     done = True
         for pkg in transaction.trans_data:
@@ -4538,8 +5970,14 @@ class YumBase(depsolve.Depsolve):
         return done
 
     def history_undo(self, transaction):
-        """ Given a valid historical transaction object, try and undo
-            that transaction. """
+        """Undo the transaction represented by the given
+        :class:`yum.history.YumHistoryTransaction` object.
+
+        :param transaction: a
+           :class:`yum.history.YumHistoryTransaction` object
+           representing the transaction to be undone
+        :return: whether the transaction was undone successfully
+        """
         # NOTE: This is somewhat basic atm. ... for instance we don't check
         #       that we are going from the old new version. However it's still
         #       better than the RHN rollback code, and people pay for that :).
@@ -4616,7 +6054,7 @@ class YumBase(depsolve.Depsolve):
 
         except urlgrabber.grabber.URLGrabError, e:
             raise Errors.YumBaseError(_('GPG key retrieval failed: ') +
-                                      to_unicode(str(e)))
+                                      exception2msg(e))
                                       
         # check for a .asc file accompanying it - that's our gpg sig on the key
         # suck it down and do the check
@@ -4649,7 +6087,7 @@ class YumBase(depsolve.Depsolve):
             keys_info = misc.getgpgkeyinfo(rawkey, multiple=True)
         except ValueError, e:
             raise Errors.YumBaseError(_('Invalid GPG Key from %s: %s') % 
-                                      (url, to_unicode(str(e))))
+                                      (url, exception2msg(e)))
         keys = []
         for keyinfo in keys_info:
             thiskey = {}
@@ -4674,39 +6112,49 @@ class YumBase(depsolve.Depsolve):
             if pkgs:
                 pkgs = sorted(pkgs)[-1]
                 msg = (_('Importing %s key 0x%s:\n'
-                         ' Userid : %s\n'
-                         ' Package: %s (%s)\n'
-                         ' From   : %s') %
+                         ' Userid     : "%s"\n'
+                         ' Fingerprint: %s\n'
+                         ' Package    : %s (%s)\n'
+                         ' From       : %s') %
                        (keytype, info['hexkeyid'], to_unicode(info['userid']),
+                        misc.gpgkey_fingerprint_ascii(info),
                         pkgs, pkgs.ui_from_repo,
                         keyurl.replace("file://","")))
         if msg is None:
             msg = (_('Importing %s key 0x%s:\n'
-                     ' Userid: "%s"\n'
-                     ' From  : %s') %
+                     ' Userid     : "%s"\n'
+                     ' Fingerprint: %s\n'
+                     ' From       : %s') %
                    (keytype, info['hexkeyid'], to_unicode(info['userid']),
+                    misc.gpgkey_fingerprint_ascii(info),
                     keyurl.replace("file://","")))
         self.logger.critical("%s", msg)
 
     def getKeyForPackage(self, po, askcb = None, fullaskcb = None):
-        """
-        Retrieve a key for a package. If needed, prompt for if the key should
-        be imported using askcb.
-        
-        @param po: Package object to retrieve the key of.
-        @param askcb: Callback function to use for asking for permission to
-                      import a key. This is verification, but also "choice".
-                      Takes arguments of the po, the userid for the key, and
-                      the keyid.
-        @param fullaskcb: Callback function to use for asking for permission to
-                          import a key. This is verification, but also "choice".
-                          Differs from askcb in that it gets passed a
-                          dictionary so that we can expand the values passed.
+        """Retrieve a key for a package. If needed, use the given
+        callback to prompt whether the key should be imported.
+
+        :param po: the package object to retrieve the key of
+        :param askcb: Callback function to use to ask permission to
+           import a key.  The arguments *askck* should take are the
+           package object, the userid of the key, and the keyid
+        :param fullaskcb: Callback function to use to ask permission to
+           import a key.  This differs from *askcb* in that it gets
+           passed a dictionary so that we can expand the values passed.
+        :raises: :class:`yum.Errors.YumBaseError` if there are errors
+           retrieving the keys
         """
         repo = self.repos.getRepo(po.repoid)
         keyurls = repo.gpgkey
         key_installed = False
 
+        def _prov_key_data(msg):
+            msg += _('\n\n\n'
+                     ' Failing package is: %s\n'
+                     ' GPG Keys are configured as: %s\n'
+                     ) % (po, ", ".join(repo.gpgkey))
+            return msg
+
         user_cb_fail = False
         for keyurl in keyurls:
             keys = self._retrievePublicKey(keyurl, repo)
@@ -4725,7 +6173,9 @@ class YumBase(depsolve.Depsolve):
                     # Try installing/updating GPG key
                     self._getKeyImportMessage(info, keyurl)
                     rc = False
-                    if self.conf.assumeyes:
+                    if self.conf.assumeno:
+                        rc = False
+                    elif self.conf.assumeyes:
                         rc = True
                         
                     # grab the .sig/.asc for the keyurl, if it exists
@@ -4751,8 +6201,8 @@ class YumBase(depsolve.Depsolve):
                 ts = self.rpmdb.readOnlyTS()
                 result = ts.pgpImportPubkey(misc.procgpgkey(info['raw_key']))
                 if result != 0:
-                    raise Errors.YumBaseError, \
-                          _('Key import failed (code %d)') % result
+                    msg = _('Key import failed (code %d)') % result
+                    raise Errors.YumBaseError, _prov_key_data(msg)
                 self.logger.info(_('Key imported successfully'))
                 key_installed = True
 
@@ -4760,18 +6210,20 @@ class YumBase(depsolve.Depsolve):
             raise Errors.YumBaseError, _("Didn't install any keys")
 
         if not key_installed:
-            raise Errors.YumBaseError, \
-                  _('The GPG keys listed for the "%s" repository are ' \
+            msg = _('The GPG keys listed for the "%s" repository are ' \
                   'already installed but they are not correct for this ' \
                   'package.\n' \
                   'Check that the correct key URLs are configured for ' \
-                  'this repository.') % (repo.name)
+                  'this repository.') % repo.name
+            raise Errors.YumBaseError, _prov_key_data(msg)
 
         # Check if the newly installed keys helped
         result, errmsg = self.sigCheckPkg(po)
         if result != 0:
-            self.logger.info(_("Import of key(s) didn't help, wrong key(s)?"))
-            raise Errors.YumBaseError, errmsg
+            msg = _("Import of key(s) didn't help, wrong key(s)?")
+            self.logger.info(msg)
+            errmsg = to_unicode(errmsg)
+            raise Errors.YumBaseError, _prov_key_data(errmsg)
     
     def _getAnyKeyForRepo(self, repo, destdir, keyurl_list, is_cakey=False, callback=None):
         """
@@ -4788,6 +6240,18 @@ class YumBase(depsolve.Depsolve):
         """
 
         key_installed = False
+
+        def _prov_key_data(msg):
+            cakeytxt = _("No")
+            if is_cakey:
+                cakeytxt = _("Yes")
+            msg += _('\n\n\n'
+                     ' CA Key: %s\n'
+                     ' Failing repo is: %s\n'
+                     ' GPG Keys are configured as: %s\n'
+                     ) % (cakeytxt, repo, ", ".join(keyurl_list))
+            return msg
+
         user_cb_fail = False
         for keyurl in keyurl_list:
             keys = self._retrievePublicKey(keyurl, repo, getSig=not is_cakey)
@@ -4819,8 +6283,11 @@ class YumBase(depsolve.Depsolve):
                 if not key_installed:
                     self._getKeyImportMessage(info, keyurl, keytype)
                     rc = False
-                    if self.conf.assumeyes:
+                    if self.conf.assumeno:
+                        rc = False
+                    elif self.conf.assumeyes:
                         rc = True
+
                     elif callback:
                         rc = callback({"repo": repo, "userid": info['userid'],
                                         "hexkeyid": info['hexkeyid'], "keyurl": keyurl,
@@ -4835,7 +6302,8 @@ class YumBase(depsolve.Depsolve):
                 # Import the key
                 result = misc.import_key_to_pubring(info['raw_key'], info['hexkeyid'], gpgdir=destdir)
                 if not result:
-                    raise Errors.YumBaseError, _('Key import failed')
+                    msg = _('Key %s import failed') % info['hexkeyid']
+                    raise Errors.YumBaseError, _prov_key_data(msg)
                 self.logger.info(_('Key imported successfully'))
                 key_installed = True
                 # write out the key id to imported_cakeys in the repos basedir
@@ -4851,36 +6319,35 @@ class YumBase(depsolve.Depsolve):
                             pass
 
         if not key_installed and user_cb_fail:
-            raise Errors.YumBaseError, _("Didn't install any keys for repo %s") % repo
+            msg = _("Didn't install any keys for repo %s") % repo
+            raise Errors.YumBaseError, _prov_key_data(msg)
 
         if not key_installed:
-            raise Errors.YumBaseError, \
+            msg = \
                   _('The GPG keys listed for the "%s" repository are ' \
                   'already installed but they are not correct.\n' \
                   'Check that the correct key URLs are configured for ' \
                   'this repository.') % (repo.name)
+            raise Errors.YumBaseError, _prov_key_data(msg)
 
     def getKeyForRepo(self, repo, callback=None):
-        """
-        Retrieve a key for a repository If needed, prompt for if the key should
-        be imported using callback
-        
-        @param repo: Repository object to retrieve the key of.
-        @param callback: Callback function to use for asking for verification
-                          of a key. Takes a dictionary of key info.
+        """Retrieve a key for a repository.  If needed, use the given
+        callback to prompt whether the key should be imported.
+
+        :param repo: repository object to retrieve the key of
+        :param callback: callback function to use for asking for
+           verification of key information
         """
         self._getAnyKeyForRepo(repo, repo.gpgdir, repo.gpgkey, is_cakey=False, callback=callback)
 
     def getCAKeyForRepo(self, repo, callback=None):
-        """
-        Retrieve a key for a repository If needed, prompt for if the key should
-        be imported using callback
-        
-        @param repo: Repository object to retrieve the key of.
-        @param callback: Callback function to use for asking for verification
-                          of a key. Takes a dictionary of key info.
-        """
+        """Retrieve a key for a repository.  If needed, use the given
+        callback to prompt whether the key should be imported.
 
+        :param repo: repository object to retrieve the key of
+        :param callback: callback function to use for asking for
+           verification of key information
+        """
         self._getAnyKeyForRepo(repo, repo.gpgcadir, repo.gpgcakey, is_cakey=True, callback=callback)
 
     def _limit_installonly_pkgs(self):
@@ -4889,7 +6356,7 @@ class YumBase(depsolve.Depsolve):
             New in 3.2.24: Obey yumdb_info.installonly data. """
 
         def _sort_and_filter_installonly(pkgs):
-            """ Allow the admin to specify some overrides fo installonly pkgs.
+            """ Allow the admin to specify some overrides for installonly pkgs.
                 using the yumdb. """
             ret_beg = []
             ret_mid = []
@@ -4917,6 +6384,10 @@ class YumBase(depsolve.Depsolve):
 
         if self.conf.installonly_limit < 1 :
             return 
+
+        # We shouldn't alter the transaction if this is set...
+        if self.tsInfo._check_future_rpmdbv:
+            return
             
         toremove = []
         #  We "probably" want to use either self.ts or self.rpmdb.ts if either
@@ -4926,23 +6397,30 @@ class YumBase(depsolve.Depsolve):
         # so self.rpmdb.ts should be valid.
         ts = self.rpmdb.readOnlyTS()
         (cur_kernel_v, cur_kernel_r) = misc.get_running_kernel_version_release(ts)
-        install_only_names = set(self.conf.installonlypkgs)
+        found = {}
         for m in self.tsInfo.getMembers():
             if m.ts_state not in ('i', 'u'):
                 continue
             if m.reinstall:
                 continue
-
-            po_names = set([m.name] + m.po.provides_names)
-            if not po_names.intersection(install_only_names):
+            if not self.allowedMultipleInstalls(m.po):
                 continue
 
-            installed = self.rpmdb.searchNevra(name=m.name)
+            if m.name not in found:
+                found[m.name] = 1
+            else:
+                found[m.name] += 1
+
+        for name in found:
+            installed = self.rpmdb.searchNevra(name=name)
             installed = _sort_and_filter_installonly(installed)
-            if len(installed) < self.conf.installonly_limit - 1:
-                continue # we're adding one
 
-            numleft = len(installed) - self.conf.installonly_limit + 1
+            total = len(installed) + found[name]
+            if total <= self.conf.installonly_limit:
+                continue # Not adding enough to trigger.
+
+            # Number left to try and remove...
+            numleft = total - self.conf.installonly_limit
             for po in installed:
                 if (po.version, po.release) == (cur_kernel_v, cur_kernel_r): 
                     # don't remove running
@@ -4959,19 +6437,22 @@ class YumBase(depsolve.Depsolve):
             txmbr.depends_on.append(rel)
 
     def processTransaction(self, callback=None,rpmTestDisplay=None, rpmDisplay=None):
-        '''
-        Process the current Transaction
-        - Download Packages
-        - Check GPG Signatures.
-        - Run Test RPM Transaction
-        - Run RPM Transaction
-        
-        callback.event method is called at start/end of each process.
-        
-        @param callback: callback object (must have an event method)
-        @param rpmTestDisplay: Name of display class to use in RPM Test Transaction 
-        @param rpmDisplay: Name of display class to use in RPM Transaction 
-        '''
+        """Process the current transaction.  This involves the
+        following steps:
+          - Download the packages
+          - Check the GPG signatures of the packages
+          - Run the test RPM transaction
+          - Run the RPM Transaction
+        The *callback*.event method is called at the start, and
+        between each step.
+
+        :param callback: a callback object, which must have an event
+           method
+        :param rpmTestDisplay: name of the display class to use in the
+           RPM test transaction
+        :param rpmDisplay: name of the display class to use in the rpm
+           transaction
+        """
         
         if not callback:
             callback = callbacks.ProcessTransNoOutputCallback()
@@ -5062,8 +6543,8 @@ class YumBase(depsolve.Depsolve):
                 raise Errors.YumRPMCheckError, retmsgs
             retmsgs = [_('ERROR with transaction check vs depsolve:')]
             retmsgs.extend(msgs) 
-            retmsgs.append(_('Please report this error at %s') 
-                                         % self.conf.bugtracker_url)
+            # Don't encourage users to file a bug here, as this is probably
+            # pre-existing issue in dependendies of installed packages
             raise Errors.YumRPMCheckError,retmsgs
         
         tsConf = {}
@@ -5114,13 +6595,19 @@ class YumBase(depsolve.Depsolve):
         return results
 
     def add_enable_repo(self, repoid, baseurls=[], mirrorlist=None, **kwargs):
-        """add and enable a repo with just a baseurl/mirrorlist and repoid
-           requires repoid and at least one of baseurl and mirrorlist
-           additional optional kwargs are:
-           variable_convert=bool (defaults to true)
-           and any other attribute settable to the normal repo setup
-           ex: metadata_expire, enable_groups, gpgcheck, cachedir, etc
-           returns the repo object it added"""
+        """Add and enable a repository.
+
+        :param repoid: a string specifying the name of the repository
+        :param baseurls: a list of strings specifying the urls for
+           the repository.  At least one base url, or one mirror, must
+           be given
+        :param mirrorlist: a list of strings specifying a list of
+           mirrors for the repository.  At least one base url, or one
+           mirror must be given
+        :param kwargs: key word arguments to set any normal repository
+           attribute
+        :return: the new repository that has been added and enabled
+        """
         # out of place fixme - maybe we should make this the default repo addition
         # routine and use it from getReposFromConfigFile(), etc.
         newrepo = yumRepo.YumRepository(repoid)
@@ -5167,9 +6654,15 @@ class YumBase(depsolve.Depsolve):
 
     def setCacheDir(self, force=False, tmpdir=None, reuse=True,
                     suffix='/$basearch/$releasever'):
-        ''' Set a new cache dir, using misc.getCacheDir() and var. replace
-            on suffix. '''
-
+        """Set a new cache directory.
+
+        :param force: whether to force the cache directory to be
+           changed
+        :param tmpdir: a temporary directory
+        :param reuse: whether the temporary directory can be reused
+        :param suffix: suffix to attach to the directory name
+        :return: whether the new cache directory is successfully set
+        """
         if not force and os.geteuid() == 0:
             return True # We are root, not forced, so happy with the global dir.
         if tmpdir is None:
@@ -5179,7 +6672,7 @@ class YumBase(depsolve.Depsolve):
         try:
             cachedir = misc.getCacheDir(tmpdir, reuse)
         except (IOError, OSError), e:
-            self.logger.critical(_('Could not set cachedir: %s') % str(e))
+            self.logger.critical(_('Could not set cachedir: %s') % exception2msg(e))
             cachedir = None
             
         if cachedir is None:
@@ -5190,6 +6683,8 @@ class YumBase(depsolve.Depsolve):
             self.prerepoconf.cachedir = cachedir
         else:
             self.repos.setCacheDir(cachedir)
+        if not hasattr(self, '_old_cachedir'):
+            self._old_cachedir = self.conf.cachedir
         self.conf.cachedir = cachedir
         return True # We got a new cache dir
 
@@ -5220,13 +6715,24 @@ class YumBase(depsolve.Depsolve):
         self.history.write_addon_data('config-repos', myrepos)
         
     def verify_plugins_cb(self, verify_package):
-        """ Callback to call a plugin hook for pkg.verify(). """
+        """Callback to call a plugin hook for pkg.verify().
+
+        :param verify_package: a conduit for the callback
+        :return: *verify_package*
+        """
         self.plugins.run('verify_package', verify_package=verify_package)
         return verify_package
 
     def save_ts(self, filename=None, auto=False):
-        """saves out a transaction to .yumtx file to be loaded later"""
-        
+        """Save out a transaction to a .yumtx file to be loaded later.
+
+        :param filename: the name of the file to save the transaction
+           in.  If *filename* is not given, a name will be generated
+        :param auto: whether to output errors to the logger, rather
+           than raising exceptions
+        :raises: :class:`yum.Errors.YumBaseError` if there are errors
+           saving the transaction
+        """
         if self.tsInfo._unresolvedMembers:
             if auto:
                 self.logger.critical(_("Dependencies not solved. Will not save unresolved transaction."))
@@ -5234,7 +6740,7 @@ class YumBase(depsolve.Depsolve):
             raise Errors.YumBaseError(_("Dependencies not solved. Will not save unresolved transaction."))
         
         if not filename:
-            prefix = 'yum_save_tx-%s' % time.strftime('%Y-%m-%d-%H-%M')
+            prefix = 'yum_save_tx.%s' % time.strftime('%Y-%m-%d.%H-%M.')
             fd,filename = tempfile.mkstemp(suffix='.yumtx', prefix=prefix)
             f = os.fdopen(fd, 'w')
         else:
@@ -5244,13 +6750,17 @@ class YumBase(depsolve.Depsolve):
         
         msg = "%s\n" % self.rpmdb.simpleVersion(main_only=True)[0]
         msg += "%s\n" % self.ts.getTsFlags()
-        if self.tsInfo.pkgSack is None: # rm Transactions don't have pkgSack
-            msg += "0\n"
+
+        if self.tsInfo._pkgSack is None: # Transactions have pkgSack?
+            msg += "1\n"
         else:
-            msg += "%s\n" % len(self.repos.listEnabled())
+            msg += "%s\n" % (len(self.repos.listEnabled()) + 1)
             for r in self.repos.listEnabled():
                 msg += "%s:%s:%s\n" % (r.id, len(r.sack), r.repoXML.revision)
 
+        # Save what we think the future rpmdbv will be.
+        msg += "%s:%s\n" % ('installed', self.tsInfo.futureRpmDBVersion())
+
         msg += "%s\n" % len(self.tsInfo.getMembers())
         for txmbr in self.tsInfo.getMembers():
             msg += txmbr._dump()
